/*
 * This file is part of decoding.
 * Copyright (C) 2012  Guillaume Quintin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

R *ll_dbpol_malloc_random(int nx,int ny) {
  int nr,i;
  R *r;
  nr = nx * ny;
  r = ll_vec_malloc_random(nr);
  if ( ll_vec_iszero(&r[(ny - 1) * nx],nx) ) {
    R_castint(r[(ny - 1) * nx],1);
  }
  for( i = nx - 1 ; i < nr ; i += nx ) {
    if ( !R_iszero(r[i]) ) goto ll_dbpol_malloc_random_ok;
  }
  R_castint(r[(nx - 1) + (nx * rand() % ny)],1);
  ll_dbpol_malloc_random_ok:;
  return r;
}

