/*
 * This file is part of decoding.
 * Copyright (C) 2012  Guillaume Quintin.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

void ll_dbpol_replace_X_by_XYn(R *r,int *nry,R *a,int nax,int nay,int n) {
  int i,j,j0;
  R *ai,*ri;
  nry[0] = (nay - 1) + n * (nax - 1) + 1;
  for( j = nry[0] - 1 ; j >= 0 ; j-- ) {
    for( i = 0 ; i < nax ; i++ ) {
      j0 = j - n * i;
      ri = &r[nax * j  + i];
      if ( j0 >= 0 && j0 < nay ) {
        ai = &a[nax * j0 + i];
        if ( ri != ai ) R_copy(ri[0],ai[0]);
      }
      else {
        R_zero(ri[0]);
      }
    }
  }
}

